// MyBtnDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MyBtn.h"
#include "MyBtnDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
#include "MyButton.h"

int sysbar_len;
const int spare_in_bottom =3;
const int spare_in_right = 3;


class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
  DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyBtnDlg dialog

CMyBtnDlg::CMyBtnDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMyBtnDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMyBtnDlg)
	m_bCellMode = TRUE;
	m_bPutty = FALSE;
	m_bHideDeact = FALSE;
	m_pCurCell = NULL;
	m_iAlignStyle = 3;
	m_bLarge = TRUE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);


}

void CMyBtnDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyBtnDlg)
	DDX_Control(pDX, IDC_TABList, m_TabList);
	DDX_Control(pDX, IDC_TABCell, m_TabCell);
	DDX_Check(pDX, IDC_CHECKCellMode, m_bCellMode);
	DDX_Check(pDX, IDC_CHECKPutty, m_bPutty);
	DDX_Check(pDX, IDC_CHECKHideDeact, m_bHideDeact);
	//}}AFX_DATA_MAP
}

const UINT WM_TASKBARCREATED = 
     ::RegisterWindowMessage(_T("TaskbarCreated"));

BEGIN_MESSAGE_MAP(CMyBtnDlg, CDialog)
	//{{AFX_MSG_MAP(CMyBtnDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON1, OnButtonShowAll)
	ON_BN_CLICKED(IDC_BUTTONMINALL, OnButtonMinAll)
	ON_BN_CLICKED(IDC_BUTTONALIGNME, OnButtonalignme)
	ON_BN_CLICKED(IDC_BUTTONExtShort, OnButtonExtShort)
	ON_BN_CLICKED(IDC_BUTTONSHOWALIGN, OnButtonshowalign)
	ON_BN_CLICKED(IDC_BUTTONSHOWALIGN2, OnButtonshowalign2)
	ON_BN_CLICKED(IDC_BUTTONMINME, OnButtonminme)
	ON_WM_LBUTTONDBLCLK()
	ON_BN_CLICKED(IDC_CHECKCellMode, OnCHECKCellMode)
	ON_BN_CLICKED(IDC_CHECKPutty, OnCHECKPutty)
	ON_WM_RBUTTONDOWN()
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_COMMAND(ID_MENUITEMAddButton, OnMENUITEMAddButton)
	ON_COMMAND(ID_MENUITEMChangeName, OnMENUITEMChangeName)
	ON_COMMAND(ID_MENUITEMAlignButtons, OnMENUITEMAlignButtons)
	ON_COMMAND(ID_MENUITEMAlignWin, OnMENUITEMAlignWin)
	ON_COMMAND(ID_MENUITEMRemove, OnMENUITEMRemove)
	ON_BN_CLICKED(IDC_CHECKHideDeact, OnCHECKHideDeact)
	ON_COMMAND(ID_MENUITEMAdjustWinPos, OnMenuitemAdjustWinPos)
	ON_COMMAND(ID_MENUITEMShowBehind, OnMENUITEMShowBehind)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TABList, OnSelchangeTABList)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TABCell, OnSelchangeTABCell)
	ON_BN_CLICKED(IDC_RADIOAlignStyle1, OnRADIOAlignStyle1)
	ON_BN_CLICKED(IDC_RADIOAlignStyle2, OnRADIOAlignStyle2)
	ON_BN_CLICKED(IDC_RADIOAlignStyle3, OnRADIOAlignStyle3)
	//}}AFX_MSG_MAP

	ON_MESSAGE(WM_HOTKEY, OnHotKey)
	ON_MESSAGE(WM_MBUTTONDOWN, OnMBtnDown)
	ON_MESSAGE(WM_TRAYICON,OnTrayNotify)
	ON_MESSAGE(WM_ACTIVATE, OnActivate)

	//tray icon
	ON_REGISTERED_MESSAGE(WM_TASKBARCREATED, OnTaskBarCreated)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyBtnDlg message handlers

BOOL CMyBtnDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	//LONG myEXStyle = ::GetWindowLong(m_hWnd, GWL_EXSTYLE);
	//myEXStyle |= WS_EX_TOOLWINDOW;
	//::SetWindowLong(m_hWnd, GWL_EXSTYLE, myEXStyle);

	LONG myStyle = ::GetWindowLong(m_hWnd, GWL_STYLE);
	//WS_THICKFRAME
	myStyle |=  WS_MINIMIZEBOX  ;
	::SetWindowLong(m_hWnd, GWL_STYLE,  myStyle);


/*#define LWA_COLORKEY 0x00000001
#define WS_EX_LAYERED 0x00080000
	
	typedef BOOL (WINAPI *lpfnSetLayeredWindowAttributes)(HWND hWnd, COLORREF crKey, BYTE bAlpha, DWORD dwFlags);
	lpfnSetLayeredWindowAttributes SetLayeredWindowAttributes;
	
	COLORREF maskColor=RGB(77, 12, 28);
	HMODULE hUser32 = GetModuleHandle("user32.dll");
	SetLayeredWindowAttributes = (lpfnSetLayeredWindowAttributes)GetProcAddress(hUser32,"SetLayeredWindowAttributes");
	SetWindowLong(GetSafeHwnd(), GWL_EXSTYLE, GetWindowLong(GetSafeHwnd(), GWL_EXSTYLE) | WS_EX_LAYERED);
	SetLayeredWindowAttributes(GetSafeHwnd(), maskColor, 255, LWA_COLORKEY);
	//SetLayeredWindowAttributes(GetSafeHwnd(), maskColor, 230, 3); //when 2, 3, ignore maskColor
	FreeLibrary(hUser32); 

*/

	//BYTE m = (BYTE)m_slider.GetPos();
	//HINSTANCE hinst = LoadLibrary("User32.DLL");
	//if(hinst)
	//{
	//	typedef BOOL (WINAPI *MYFUN)(HWND,COLORREF,BYTE,DWORD);
	//	MYFUN fun = NULL;
	//	fun = (MYFUN)GetProcAddress(hinst,"SetLayeredWindowAttributes");
	//	if(fun)                           
	//	{
	//		fun(AfxGetMainWnd()->GetSafeHwnd(),0,m,2);
	//	}
	//	FreeLibrary(hinst);
	//}  



	//cs.style =WS_POPUP;
    //cs.dwExStyle |=WS_EX_TOOLWINDOW;

	//::SetClassLong(m_hWnd, GCL_HBRBACKGROUND, (long)::GetStockObject(BLACK_BRUSH)); 
	
	m_kGetWindow = GlobalAddAtom("WINBOX1");
	if (!::RegisterHotKey(m_hWnd, m_kGetWindow, MOD_WIN, 'A'))
	{
		MessageBox("failed to reg hotkey");	
	}

	m_kBringMe = GlobalAddAtom("WINBOX:BringME");

	if (!::RegisterHotKey(m_hWnd, m_kBringMe, MOD_WIN, 'Z'))
	{
		MessageBox("failed to reg hotkey bringme");	
	}

	m_kShowGroup = GlobalAddAtom("WINBOX:ShowGroup");

	if (!::RegisterHotKey(m_hWnd, m_kShowGroup, MOD_WIN, 'Q'))
	{
		MessageBox("failed to reg hotkey showgroup");	
	}

	m_kAlignWin = GlobalAddAtom("WINBOX:AlignWin");

	if (!::RegisterHotKey(m_hWnd, m_kAlignWin, MOD_WIN, 'P'))
	{
		MessageBox("failed to reg hotkey AlignWin");	
	}

	m_kNextPage = GlobalAddAtom("WINBOX:NextPage");

	if (!::RegisterHotKey(m_hWnd, m_kNextPage, MOD_WIN, 'C'))
	{
		MessageBox("failed to reg hotkey NextPage");	
	}

	m_kPrevPage = GlobalAddAtom("WINBOX:PrevPage");

	if (!::RegisterHotKey(m_hWnd, m_kPrevPage, MOD_WIN, 'X'))
	{
		MessageBox("failed to reg hotkey PrevPage");	
	}

	m_kMinAll = GlobalAddAtom("WINBOX:MinAll");

	if (!::RegisterHotKey(m_hWnd, m_kMinAll, MOD_WIN, 'W'))
	{
		MessageBox("failed to reg hotkey MinAll");	
	}

	this->m_menuCell.LoadMenu(IDR_MENU1);
	//this->SetMenu(&m_menuCell);

	this->GetClientRect(&m_AlignRect);

	CRect rect;

	this->GetWindowRect(&rect);
	m_FullDlgRect.left = 0;
	m_FullDlgRect.top =0;
	m_FullDlgRect.bottom =rect.Height();
	m_FullDlgRect.right = rect.Width();

	this->GetClientRect(&rect);
	sysbar_len = m_FullDlgRect.Height() - rect.Height();

	this->GetDlgItem(IDC_STATIC_V)->GetWindowRect(&rect);
	//m_AlignRect.right = rect.left - spare_in_right;
	m_AlignRect.left = rect.right;

	this->GetDlgItem(IDC_STATIC_H)->GetWindowRect(&rect);
	m_AlignRect.bottom = rect.top - sysbar_len - spare_in_bottom;

	//m_AlignRect.left += 8;
	m_AlignRect.right -= spare_in_right;
	m_AlignRect.top  += 8;
		
	m_orgCursor=(HCURSOR)::GetClassLong(m_hWnd, GCL_HCURSOR);
	//::SetClassLong(m_hWnd, GCL_HCURSOR, NULL);
	//::SetCursor(m_orgCursor);



	this->GetDlgItem(IDC_STATICCellSmall)->GetWindowRect(&m_rCellSmall);
	m_rCellSmall.top -= sysbar_len;
	m_rCellSmall.bottom -= sysbar_len;
	//m_pCurCell->Create(m_rCellSmall, this);


	OnButtonExtShort();


	// Add Tabs
	//Cell TAB:
	CString str;
	int i;
	for (i=0; i< CellCount; i++)
	{
		str.Format("C %d", i+1);
		this->m_TabCell.InsertItem(i, str);
	
		m_CellRectArray[i].Create(m_AlignRect, this);
		m_CellRectArray[i].m_orgCursor = m_orgCursor;
		m_CellRectArray[i].SetBitmap(IDB_BITMAP1, IDB_BITMAP2);
		//m_CellRectArray[i].SetBitmapMode(TRUE);

	}

	this->m_pCurCell = & m_CellRectArray[0];

	for (i=0; i< ListCount; i++)
	{
		str.Format("B %d", i+1);
		this->m_TabList.InsertItem(i, str);
	}

	m_pCurBtnList = & m_BtnListArray[0];

	CButton * pbstyle = (CButton *) GetDlgItem(IDC_RADIOAlignStyle3);
	pbstyle->SetCheck(1);


	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMyBtnDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else if (nID == SC_MINIMIZE )
	{
		ShowWindow(SW_HIDE);
		return;
	}
	else if (nID == SC_CLOSE)
	{
		int ret = MessageBox("Do you really want ot quit", "Warning", MB_OKCANCEL);
	
		if (ret == 2) // cancel
		{
			return;
		}else
		{
			CDialog::OnSysCommand(nID, lParam);
		}
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMyBtnDlg::OnPaint() 
{


	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}

	/*
	CRect staticR, clR, r;

	this->GetDlgItem(IDC_STATICTransport)->GetWindowRect(&staticR);
	this->ScreenToClient(&staticR);

	this->GetClientRect(&clR);

	r.left=staticR.left;
	r.top = staticR.top;
	r.right = staticR.right;
	r.bottom = clR.bottom;

	CClientDC dc(this);

	CBrush br;
	br.CreateSolidBrush(RGB(77, 12, 28));
	CBrush *oldBrush = dc.SelectObject(&br);

	dc.Rectangle(&r);

	if (m_bCellMode)
	{
		CRect cellR;
		this->GetDlgItem(IDC_STATICCellSmall)->GetWindowRect(&cellR);
		this->ScreenToClient(&cellR);
		dc.Rectangle(&cellR);

	}

	dc.SelectObject(oldBrush);
	*/

	this->m_pCurCell->Draw();


}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMyBtnDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMyBtnDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

	this->m_pCurCell->OnLButtonDown(nFlags, point);

	CDialog::OnLButtonDown(nFlags, point);

	//this->SetCapture();
}

void CMyBtnDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

	//ReleaseCapture();
	this->m_pCurCell->OnLButtonUp(nFlags, point);

	CDialog::OnLButtonUp(nFlags, point);
}


void CMyBtnDlg::OnButton4() 
{
	// TODO: Add your control notification handler code here
   
	int ret = MessageBox("Do you really want ot clear all", "Warning", MB_OKCANCEL);
	
	if (ret == 2) // cancel
	{
		return;
	}


	m_pCurBtnList->RemoveAll();

}

void CMyBtnDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here

	Shell_NotifyIcon(NIM_DELETE, &m_trayIcon);

	// Remove the HotKey

	if (!(UnregisterHotKey(m_hWnd, this->m_kGetWindow)))
	{
		MessageBox("Failed to unregister hotkey getwindow");
	}

	if (!(UnregisterHotKey(m_hWnd, this->m_kBringMe)))
	{
		MessageBox("Failed to unregister hotkey bringme");
	}

	if (!(UnregisterHotKey(m_hWnd, this->m_kShowGroup)))
	{
		MessageBox("Failed to unregister hotkey showgroup");
	}

	if (!(UnregisterHotKey(m_hWnd, this->m_kAlignWin)))
	{
		MessageBox("Failed to unregister hotkey AlignWin");
	}

	if (!(UnregisterHotKey(m_hWnd, this->m_kNextPage)))
	{
		MessageBox("Failed to unregister hotkey NextPage");
	}
	
	if (!(UnregisterHotKey(m_hWnd, this->m_kPrevPage)))
	{
		MessageBox("Failed to unregister hotkey PrevPage");
	}

	if (!(UnregisterHotKey(m_hWnd, this->m_kMinAll)))
	{
		MessageBox("Failed to unregister hotkey MinAll");
	}


}

LRESULT CMyBtnDlg::OnMBtnDown(WPARAM wParam,LPARAM lParam)
{

	return m_pCurCell->OnMBtnDown(wParam, lParam);

}

LRESULT CMyBtnDlg::OnHotKey(WPARAM wParam,LPARAM lParam)
{

	if (wParam == m_kGetWindow){
		
		HWND fwin=::GetForegroundWindow();

		if ((fwin != this->m_hWnd)&& (fwin !=::GetDesktopWindow())){

			if (this->m_bCellMode)
			{
				//pBtn->ShowWindow(SW_HIDE);

				this->m_pCurCell->AddToCell(fwin);
				this->m_pCurCell->Draw();
			}
			else
			{
				AddButton(fwin);
			}

		}


		
	} else if (wParam == m_kBringMe){
		if (IsIconic())
		{
			ShowWindow(SW_SHOWNOACTIVATE);
		}

		if (!IsWindowVisible())
		{
			this->ShowWindow(SW_SHOW);
		}

		::SetForegroundWindow(this->m_hWnd);

	} else if (wParam == m_kShowGroup){

		if (m_bPutty)
		{
			this->OnButtonshowalign();
		}
		else
		{
			this->OnButtonshowalign2();
		}

	} else if (wParam == m_kAlignWin){

		int count = m_pCurCell->AlignWnd(this->m_iAlignStyle);

		if ( 1 == count)
		{
			m_pCurCell->ShowGroup();
		}
	
		if (count > 0)
		{
				
			ShowWindow(SW_HIDE);
		}

		m_pCurBtnList->ShowGroupWnd();

	}else if (wParam == m_kMinAll){

		OnButtonMinAll();

	} else if ((wParam == m_kNextPage) || (wParam == m_kPrevPage)){

		int cur = m_TabCell.GetCurSel();

		int np;

		if (wParam == m_kNextPage){
			
			np = (cur + 1) % CellCount;
		} else {
			np = (cur - 1 + CellCount) % CellCount;
		}

		m_TabCell.SetCurSel(np);
		m_pCurCell = & m_CellRectArray[np];

		
		if (this->m_bCellMode) {
			
			m_pCurCell->SetRect(this->m_AlignRect);
			m_pCurCell->SetBitmapMode(FALSE);
			
		} else
		{
			
			m_pCurCell->SetRect(this->m_rCellSmall);
			m_pCurCell->SetBitmapMode(TRUE);
			
		}

		m_pCurCell->Draw();
		m_pCurCell->ShowGroup();


	}

	return 0;
}

void CMyBtnDlg::OnButtonShowAll() 
{
	// TODO: Add your control notification handler code here

	this->m_pCurBtnList->ShowAllWnd();
	this->m_pCurCell->ShowAllWnd();

}


void CMyBtnDlg::OnButtonMinAll() 
{
	// TODO: Add your control notification handler code here
	m_pCurBtnList->MiniAllWnd();
	m_pCurCell->MiniAll();

}



void CMyBtnDlg::OnButtonExtShort() 
{	

	if (m_bLarge)
	{
		CRect rect;

		rect = m_FullDlgRect;

		rect.bottom = m_AlignRect.bottom + sysbar_len + spare_in_bottom;

		this->SetWindowPos(NULL, 0, 0, rect.Width(), rect.Height(),
			SWP_NOMOVE | SWP_NOZORDER);

		this->GetDlgItem(IDC_BUTTONExtShort)->SetWindowText(">>");

		m_bLarge =FALSE;
	}else
	{
		this->SetWindowPos(NULL, 0, 0, m_FullDlgRect.Width(), m_FullDlgRect.Height(),
			SWP_NOMOVE | SWP_NOZORDER);

		this->GetDlgItem(IDC_BUTTONExtShort)->SetWindowText("<<");

		m_bLarge =TRUE;

	}
}

void CMyBtnDlg::OnButtonalignme() 
{
	// TODO: Add your control notification handler code here

	int ret = MessageBox("Do you really want ot align buttons?", "Warning", MB_OKCANCEL);
	
	if (ret == 2) // cancel
	{
		return;
	}

	m_pCurBtnList->AlignMeLayout(this->m_AlignRect);


	this ->Invalidate();
}


void CMyBtnDlg::OnButtonshowalign() 
{
	// TODO: Add your control notification handler code here

	if (!m_bPutty)
	{
	int ret = MessageBox("Do you really want ot align windows", "Warning", MB_OKCANCEL);
	
	if (ret == 2) // cancel
	{
		return;
	}
	}

	int count = m_pCurCell->AlignWnd(this->m_iAlignStyle);

	if ( 1 == count)
	{
		m_pCurCell->ShowGroup();
	}
	
	if (count > 0)
	{
		
		ShowWindow(SW_HIDE);
	}

	m_pCurBtnList->ShowGroupWnd();



}

void CMyBtnDlg::OnButtonshowalign2() 
{
	// TODO: Add your control notification handler code here

	m_pCurCell->ShowGroup();
	m_pCurBtnList->ShowGroupWnd();

}



void CMyBtnDlg::HideAll()
{
	m_pCurBtnList->ShowAllBtn(FALSE);
}

void CMyBtnDlg::ShowAll()
{
	m_pCurBtnList->ShowAllBtn(TRUE);
}


void CMyBtnDlg::OnButtonminme() 
{
	// TODO: Add your control notification handler code here
	this->ShowWindow(SW_SHOWMINIMIZED);
	
}



void CMyBtnDlg::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

	if (!m_pCurCell->OnLButtonDblClk(nFlags, point))
	{
		//this->ShowWindow(SW_SHOWMINIMIZED);
		this->ShowWindow(SW_HIDE);

		if (m_bPutty)
		{
			this->OnButtonshowalign();
		}
		else
		{
			this->OnButtonshowalign2();
		}
	}

	CDialog::OnLButtonDblClk(nFlags, point);
}



void CMyBtnDlg::OnCHECKCellMode() 
{
	// TODO: Add your control notification handler code here
	this->UpdateData();

	if (this->m_bCellMode) {
		
		HideAll(); // hide all button;


		m_pCurCell->SetRect(this->m_AlignRect);
		m_pCurCell->SetBitmapMode(FALSE);

	} else
	{
		ShowAll();

		m_pCurCell->SetRect(this->m_rCellSmall);
		m_pCurCell->SetBitmapMode(TRUE);

	}

	this->GetDlgItem(IDC_BUTTONALIGNME)->EnableWindow(!m_bCellMode);
 


	this->Invalidate();
	
}

void CMyBtnDlg::OnCHECKPutty() 
{
	// TODO: Add your control notification handler code here
	this->UpdateData();
}



void CMyBtnDlg::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

	if (m_pCurCell->PtInRect(point))
	{
		m_pCurCell->OnRButtonDown(nFlags, point);
	}
	else
	{
		CPoint pt = point;
		this->ClientToScreen(&pt);

		CMenu * submenu = m_menuCell.GetSubMenu(2);

		if (m_bCellMode)
		{
			submenu->EnableMenuItem(ID_MENUITEMAlignButtons, MF_GRAYED);
		}
		else
		{
			submenu->EnableMenuItem(ID_MENUITEMAlignButtons, MF_ENABLED);
		}

		submenu->TrackPopupMenu(TPM_LEFTALIGN, pt.x, pt.y, this, NULL);

	}


	CDialog::OnRButtonDown(nFlags, point);
}


//void CMyBtnDlg::OnCancel( ){}

BOOL CMyBtnDlg::PreTranslateMessage(MSG*   pMsg)    
{  
    if(pMsg->message==WM_KEYDOWN   &&   pMsg->wParam==VK_ESCAPE)   
	{
		//pMsg->wParam=VK_RETURN;
		return   TRUE;  
	}
    //if(pMsg->message==WM_KEYDOWN   &&   pMsg->wParam==VK_RETURN)   return   TRUE;    
    else      
		return   CDialog::PreTranslateMessage(pMsg);  
 }   


void CMyBtnDlg::AddToCell(HWND hWnd)
{

	this->m_pCurCell->AddToCell(hWnd);
	this->m_pCurCell->Draw();
}

void CMyBtnDlg::AddToCell(HWND hWnd, int row, int col)
{

	this->m_pCurCell->AddCell(hWnd, row, col);
	this->m_pCurCell->Draw();
}



int CMyBtnDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here

	CString str;
	str.LoadString(IDS_TOOLTIP);

	m_trayIcon.cbSize = sizeof(NOTIFYICONDATA);
	m_trayIcon.hIcon = m_hIcon;
		
		//(HICON)LoadImage(AfxGetApp()->m_hInstance,
		//	MAKEINTRESOURCE(IDR_MAINFRAME), IMAGE_ICON, 16, 16, 0);
	m_trayIcon.hWnd = m_hWnd;
	m_trayIcon.uID = MAINTRAYICON;
	m_trayIcon.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
	m_trayIcon.uCallbackMessage = WM_TRAYICON;
	strcpy(m_trayIcon.szTip, str);

	Shell_NotifyIcon(NIM_ADD, &m_trayIcon);


	return 0;
}

LRESULT CMyBtnDlg::OnTrayNotify(WPARAM wParam, LPARAM lParam)
{

	if (wParam != MAINTRAYICON)
	{
		return 0;
	}

	switch(lParam)
	{
		
	case WM_LBUTTONUP:

		if (this->IsWindowVisible())
		{
			ShowWindow(SW_HIDE);
		}
		else
		{
			ShowWindow(SW_SHOWNORMAL);
			SetForegroundWindow();
		}
		break;

	//case WM_RBUTTONDOWN:

	//	break;
	//case WM_LBUTTONDBLCLK:

	//	break;
	default:
	break;
	}

	return 0;

}




void CMyBtnDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	this->m_AlignRect.right = cx - spare_in_right;
	this->m_AlignRect.bottom = cy - spare_in_bottom;

	if (m_AlignRect.left > m_AlignRect.right)
	{
		m_AlignRect.right = m_AlignRect.left;
	}

	if (m_AlignRect.top > m_AlignRect.bottom)
	{
		m_AlignRect.bottom = m_AlignRect.top;
	}

	if ((this->m_bCellMode) && (m_pCurCell != NULL))
	{
		m_pCurCell->SetRect(m_AlignRect);
		Invalidate();
	}

	// Adjust TABs
	if (m_pCurCell != NULL)
	{
		CRect r;
		
		this->m_TabCell.GetWindowRect(&r);
		this->ScreenToClient(&r);
		this->m_TabCell.SetWindowPos(NULL, 0, 0, r.Width(), cy-r.top, SWP_NOMOVE | SWP_NOZORDER);
		
		this->m_TabList.GetWindowRect(&r);
		this->ScreenToClient(&r);
		this->m_TabList.SetWindowPos(NULL, 0, 0, r.Width(), cy-r.top, SWP_NOMOVE | SWP_NOZORDER);
	}
}



 LRESULT CMyBtnDlg::OnTaskBarCreated(WPARAM wp, LPARAM lp)
 {

	 Shell_NotifyIcon(NIM_ADD, &m_trayIcon);
     return 0;
 }


void CMyBtnDlg::OnMENUITEMAddButton() 
{
	// TODO: Add your command handler code here
	HWND hWnd = this->m_pCurCell->GetHWndAddBtn();

	AddButton(hWnd);
	
}

CWnd* CMyBtnDlg::AddButton(HWND hWnd, CPoint point)
{
	
	char ch[30];
	::GetWindowText(hWnd, ch, 30);
	
	CString str(ch);
	
	CRect rect;
	
	rect.left = this->m_AlignRect.right - 80;
	rect.top  = this->m_AlignRect.bottom -80;
	rect.bottom = this->m_AlignRect.bottom;
	rect.right = this->m_AlignRect.right;
	
	CMyButton * pBtn;
	
	pBtn = (CMyButton *)m_pCurBtnList->FindBtn(hWnd);
	
	if (pBtn != NULL)
	{
		
		pBtn->SetFocus();
	}
	else
	{
		
		pBtn = new CMyButton();
		pBtn->Create(str, WS_CHILD | BS_DEFPUSHBUTTON |WS_VISIBLE | WS_THICKFRAME, 
			rect, this, 111);
		
		
		pBtn->m_hIcon = (HICON)::GetClassLong(hWnd, GCL_HICONSM);
		pBtn->m_hConnectWnd=hWnd;
		
		pBtn->ModifyStyle(0, BS_OWNERDRAW);
		
		
		
		m_pCurBtnList->AddBtn(pBtn);
		pBtn->SetFocus();
		
	}
	
	if (this->m_bCellMode)
	{
		pBtn->ShowWindow(SW_HIDE);			
	}
	else
	{
		if (m_AlignRect.PtInRect(point))
		{
			pBtn->SetWindowPos(NULL, point.x, point.y, 0 , 0, 
				SWP_NOSIZE | SWP_NOZORDER |SWP_NOACTIVATE);
		}
	}
	
	return pBtn;
	
}

void CMyBtnDlg::OnMENUITEMChangeName() 
{
	// TODO: Add your command handler code here

	this->m_pCurCell->ChangeCellName();
	
}



void CMyBtnDlg::OnMENUITEMAlignButtons() 
{
	// TODO: Add your command handler code here
	OnButtonalignme();
}

void CMyBtnDlg::OnMENUITEMAlignWin() 
{
	// TODO: Add your command handler code here
	OnButtonshowalign();
	
}

//DEL void CMyBtnDlg::OnButton2() 
//DEL {
//DEL 	// TODO: Add your control notification handler code here
//DEL 	//::SetForegroundWindow(this->m_pCurCell->m_CellData[0][0]->m_hConnectWnd);
//DEL 	//::SendMessage(this->m_pCurCell->m_CellData[0][0]->m_hConnectWnd, WM_KEYDOWN, 'a', 0);
//DEL 	::SendMessage(this->m_pCurCell->m_CellData[0][0]->m_hConnectWnd, WM_CHAR, 'l', 0);
//DEL 	::SendMessage(this->m_pCurCell->m_CellData[0][0]->m_hConnectWnd, WM_CHAR, 's', 0);
//DEL 	::SendMessage(this->m_pCurCell->m_CellData[0][0]->m_hConnectWnd, WM_CHAR, ' ', 0);
//DEL 	//::SendMessage(this->m_pCurCell->m_CellData[0][0]->m_hConnectWnd, WM_KEYUP, 'a', 0);
//DEL 	::SendMessage(this->m_pCurCell->m_CellData[0][0]->m_hConnectWnd, WM_CHAR, VK_RETURN, 0);
//DEL 
//DEL 	::SendMessage(this->m_pCurCell->m_CellData[0][0]->m_hConnectWnd, WM_CHAR, 'x', 0);
//DEL 	::SendMessage(this->m_pCurCell->m_CellData[0][0]->m_hConnectWnd, WM_CHAR, VK_RETURN, 0);
//DEL 	
//DEL 			this->ShowWindow(SW_MINIMIZE);
//DEL 
//DEL 	/*STARTUPINFO sui;
//DEL 	PROCESS_INFORMATION pi;
//DEL 	
//DEL 	ZeroMemory(&sui, sizeof(STARTUPINFO));
//DEL 	sui.cb = sizeof(STARTUPINFO);
//DEL 
//DEL 	if (CreateProcess("C:\\Documents and Settings\\WinGer\\\\putty.exe", "putty.exe 202.38.33.182", 
//DEL 		NULL, NULL, FALSE, 0, NULL, NULL, &sui, &pi))
//DEL 	{
//DEL 		::CloseHandle(pi.hProcess);
//DEL 		::CloseHandle(pi.hThread);
//DEL 
//DEL 
//DEL 		this->m_pCurCell->AddToCell(::GetForegroundWindow());
//DEL 	}*/
//DEL }

void CMyBtnDlg::OnMENUITEMRemove() 
{
	// TODO: Add your command handler code here
	this->m_pCurCell->DelFromCell(m_pCurCell->GetHWndAddBtn());
	m_pCurCell->Draw();
	
}

BOOL CMyBtnDlg::DelFromCell(HWND hWnd)
{
	if (m_pCurCell->DelFromCell(hWnd))
	{
		m_pCurCell->Draw();
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

LRESULT CMyBtnDlg::OnActivate(WPARAM wParam, LPARAM lParam)
{
	//fActive = LOWORD(wParam);           // activation flag 
	//fMinimized = (BOOL) HIWORD(wParam); // minimized flag 
	//hwndPrevious = (HWND) lParam;       // window handle 
	
	if (this->m_bHideDeact)
	{
		if (WA_INACTIVE == LOWORD(wParam))
		{
			
			this->ShowWindow(SW_HIDE);
		}
	}
	return 0;

}



void CMyBtnDlg::OnCHECKHideDeact() 
{
	// TODO: Add your control notification handler code here

	this->UpdateData();
}

void CMyBtnDlg::OnMyButtonUp(UINT nFlags, CPoint point, CMyButton *pBtn)
{

	this->m_pCurCell->OnMyButtonUp(nFlags, point, pBtn);
}

BOOL CMyBtnDlg::DelButton(CMyButton *pBtn)
{

	this->m_pCurBtnList->RemoveBtn(pBtn);

	delete pBtn;

	return TRUE;
}

void CMyBtnDlg::OnMenuitemAdjustWinPos() 
{
	// TODO: Add your command handler code here
	m_pCurCell->AdjustWinPos(this->m_iAlignStyle);
	
}

void CMyBtnDlg::OnMENUITEMShowBehind() 
{
	// TODO: Add your command handler code here

	m_pCurCell->SetShowBehind();
	m_pCurCell->Draw();
	
}

void CMyBtnDlg::OnSelchangeTABList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	int cur = m_TabList.GetCurSel();
	
	if (m_bCellMode)
	{
		this->m_pCurBtnList = & m_BtnListArray[cur];
	}
	else
	{
		m_pCurBtnList->ShowAllBtn(FALSE);
		this->m_pCurBtnList = & m_BtnListArray[cur];
		this->m_pCurBtnList->ShowAllBtn(TRUE);
	}

	*pResult = 0;
}

void CMyBtnDlg::OnSelchangeTABCell(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	

	int cur = m_TabCell.GetCurSel();
	m_pCurCell = & m_CellRectArray[cur];

	if (this->m_bCellMode) {
		
		m_pCurCell->SetRect(this->m_AlignRect);
		m_pCurCell->SetBitmapMode(FALSE);

	} else
	{

		m_pCurCell->SetRect(this->m_rCellSmall);
		m_pCurCell->SetBitmapMode(TRUE);

	}
	m_pCurCell->Draw();

	*pResult = 0;
}

void CMyBtnDlg::OnRADIOAlignStyle1() 
{
	// TODO: Add your control notification handler code here
	this->m_iAlignStyle = 1;
}

void CMyBtnDlg::OnRADIOAlignStyle2() 
{
	// TODO: Add your control notification handler code here
	this->m_iAlignStyle = 2;
	
}

void CMyBtnDlg::OnRADIOAlignStyle3() 
{
	// TODO: Add your control notification handler code here
	this->m_iAlignStyle = 3;
	
}
